#ifndef ____XVIDEOSHOW_HPP__INCLUDED____
#define ____XVIDEOSHOW_HPP__INCLUDED____



#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/extensions/XShm.h>
#include <X11/extensions/Xv.h>
#include <X11/extensions/Xvlib.h>



#define GUID_YUY2_PACKED  0x32595559 



class XVideoShow
{
public:
  XVideoShow(char *Name, int ImageWidth, int ImageHeight);
  virtual ~XVideoShow();
  int                  Go();              // start the show

protected:

  virtual int          UpdateImageData(); // update m_Image contents
  XvImage *            m_Image;           // the image, i.e. the frame to show

private:
  int                  OpenDisplay();
  int                  OpenWindow();
  int                  GetVideoPort();
  int                  CreateImage();
  int                  PlayVideo();
  int                  SelectBestDisplay();
  int                  VideoPortHasYUY2(XvPortID port);
  int                  EatEvents();
  char *               m_WindowName;
  int                  m_Width;
  int                  m_Height;
  Display *            m_Display;
  int                  m_VideoPort;

  XVisualInfo          m_VisInfo;
  XSetWindowAttributes m_Xswa;
  Window               m_Window;
  XShmSegmentInfo      m_ShmInfo;



  Window               dw;
  unsigned int         d;
  unsigned int         w; 
  unsigned int         h;
  unsigned int         saved_w; 
  unsigned int         saved_h;
};



#endif
